
;------------------------------------------------------------------------------------------
; ----------------- miscellaneous procs for setting up the timing test --------------------
;------------------------------------------------------------------------------------------

.data
CallTable dd MaxTests dup (0)		; up to MaxTests tests allowed
TableEnd	equ $

ProgName	db 'Timing Test',0
.data?
align 4
CurProcess	dd ?
TestNum 	dd ?
htemp		dd ?
;Loops		dd ?
hFnt 		dd ?
.code
DlgProc	proc uses ebx, hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if	uMsg == WM_COMMAND
		.if	wParam > 2000 && wParam < 2999 ; one of the test buttons
			pusha
			mov eax,wParam
			sub eax,2000
			mov TestNum,eax	; save the actual test number, 1..999
			invoke GetCurrentProcess
			mov [CurProcess],eax
			invoke SetPriorityClass, CurProcess, REALTIME_PRIORITY_CLASS
			invoke SetProcessPriorityBoost, CurProcess, FALSE	; normal behavior
			invoke SetThreadPriority, CurProcess, THREAD_PRIORITY_TIME_CRITICAL
			mov eax,TestNum
			sub eax,1
			mov eax,[CallTable+eax*4]
			.if eax!=0
				call eax  	; call Doit1 or Doit2 or .... DoitN
			.endif
			invoke SetThreadPriority, CurProcess, THREAD_PRIORITY_NORMAL
			invoke SetPriorityClass, CurProcess, NORMAL_PRIORITY_CLASS
			popa
		.endif
    .elseif uMsg== WM_INITDIALOG
		pusha
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
		inv SendMessage,hWin,WM_GETFONT,0,0	; get the font for the controls to use
		mov hFnt,eax

		call CallTableSetup	; go set up the address for the procs to test, add controls, etc.		
		mov ebx,1006	; print out number of times we are looping
		GetHandle ebx,htemp
		invoke wsprintf,addr buff,soff("%i"),TimesToLoop
		invoke SendMessage,htemp,WM_SETTEXT,0,addr buff
		BeginCounter
		; null test to get overhead
		EndCounter
		mov eax,Result
		mov OverHead,eax
		
		popa
	.elseif	uMsg == WM_CLOSE
		invoke	EndDialog,hWin,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp


.data
Wide1 = 50  	; width of Test Button
Wide2 = 212 	; width of Description
Wide3 = 75  	; width of Clock Cycles
Wide4 = 75  	; width of Average Clocks
Wide5 = 75  	; width of scratch
Left1 = 11		; Button   2001, 2002, .... , 2020   
Left2 = Left1+Wide1+4		; Edit 1, Description, will compute location, 3001, 3002, ... , 3020
Left3 = Left2+Wide2+2		; Edit 2, Clock Cycles, 4001, ...
Left4 = Left3+Wide3+2		; Edit 3, Average Clocks 5001, ...
Left5 = Left4+Wide4+2		; Edit 4, Test routine scratch for output value if desired, 6001, ...
TDel  = 32  	; Delta between rows
Top  dd 32	 	; top of all, will increment by TDel
Ht	 dd TDel		; height of rows
blank   db ' ',0
edt		db 'EDIT',0,0
CtlGp	dd	2000	; base id

.code
MakeControls proc
	mov eax,2000		; each starts with id 2000+TestNum
	add eax,TestNum
	mov CtlGp,eax
	inv CreateWindowEx,0,soff("BUTTON"),addr buff,
			WS_CHILD or WS_VISIBLE or WS_TABSTOP,
			Left1,Top,Wide1,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,addr blank,
			WS_VISIBLE or WS_CHILDWINDOW or ES_NOHIDESEL or ES_MULTILINE,
	        Left2,Top,Wide2,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,soff(" "),
			WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
			Left3,Top,Wide3,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,soff(" "),
			WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
			Left4,Top,Wide4,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	add CtlGp,1000
	
	inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,soff(" "),
			WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL,
			Left5,Top,Wide5,Ht,hWin,CtlGp,temp1,NULL
	inv SendMessage,eax,WM_SETFONT,hFnt,TRUE

	mov eax,TDel	; set up for next group
	add Top,eax

	ret
MakeControls EndP

.data
ctsfmt db "Test %i",0
WinRect   RECT <?>  ; left,top,right,bottom of Dialog window
.code

CallTableSetup:  ; call table setup, save offsets of tests, and also add controls to dialog
	mov TestNum,1	; step through ids 1-MaxTests
	mov ebx,offset CallTable
	num=0
	Repeat MaxTests
		num=num+1
		arg CatStr <Doit>, %num		;; construct  Doit1, Doit2, etc.
		if (opattr(arg)) and 01y	;; if it is a label
			mov [ebx],offset arg
			pusha	;; save everything while we add controls, etc.
			inv wsprintf,addr buff,addr ctsfmt,TestNum   ; get button caption
			call MakeControls
			mov eax,offset arg
			call eax  		; call for first time just to get description
			popa
		endif
		add ebx,4		;; set up for next store address
		add TestNum,1		;; set up for next ID
	endm	

	; set window height here
    inv GetWindowRect,hWin,addr WinRect
    mov eax,WinRect.right
    sub eax,WinRect.left        ;width of dialog
    mov WinRect.right,eax       ;save width
    mov	eax,Top					; would be top of next row added
    mov	WinRect.bottom,eax
    add WinRect.bottom,TDel		;new height
    inv MoveWindow,hWin,WinRect.left,WinRect.top,WinRect.right,WinRect.bottom,TRUE   
	ret

SetDesc proc	; enter with Description Offset in ebx
	pusha		; save users setup if any
	push ebx	
	mov eax,TestNum
	add eax,3000		; get the id of the description box
	GetHandle eax,htemp
	pop	ebx		; get back Description offset
	invoke SendMessage,htemp,WM_SETTEXT,0,ebx
	popa
	ret
SetDesc EndP

;Wrapup2 proc
;	mov Average,eax
;	invoke wsprintf,addr buff,soff("%i"),Average
;	mov eax,TestNum
;	add eax,5000		; Average cycles
;	GetHandle eax,htemp
;	invoke SendMessage,htemp,WM_SETTEXT,0,addr buff
;	ret
;Wrapup2 EndP
end start
